#!/usr/bin/perl
#   hhc2html.pl
#   convert contents file in chm to html format
#
#   Copyright (c) 2003 by Samuel Yang <labourvanity@yahoo.com.tw>
#
#   This program is free software;
#   You can redistribute it and/or modify it under the terms of
#   the GNU Lesser General Public License (version 2) as published by
#   the Free Software Foundation.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this package; if not, contact to me.
#
#  version 0.1a

$,=" ";
$\="\n";

$obj="<object [^>]*>";
$param="<param [^>]*>";
@quote=( '([^ \'"]+)[ >]', "('[^']+')", '("[^"]+")' );
$typereg=" type=($quote[0]|$quote[1]|$quote[2])";
$namereg=" name=($quote[0]|$quote[1]|$quote[2])";
$valuereg=" value=($quote[0]|$quote[1]|$quote[2])";

GLOBAL: while(<>){
    chomp;
    next GLOBAL unless /(.*)($obj)(.*)/i || !print $_;
    $pre=$1; $_=$2; $post=$3;
    next GLOBAL unless /$typereg/i || !print $pre.$_.$post;
    $type=$4;
    next GLOBAL unless $type =~ /text\/sitemap/i || !print $pre.$_.$post;
    print $pre."<div>".$post;
    $name="";
    $local="";
    OBJECT: while(<>){
	last OBJECT if /<\/object>/i && print "<a href=$local>$name</a></div>";
	if( /(.*)($param)(.*)/i ){
	    $pre=$1; $_=$2; $post=$3;
	    print $pre,$post;
	    next OBJECT unless /$valuereg/i;
	    $value=$4;
	    next OBJECT unless /$namereg/i;
	    $_ = lc $4;
	    s/(^["'])|(["']$)//g;
	    $value= lc $value if /local/;
	    eval '$'.$_."=".$value if /(local)|(name)/;
	}else{
	    print;
	}
    }
}
